unit hiFileMapping;

interface

uses Kol,Windows,Share,Debug;

type
  THIFileMapping = class(TDebug)
   private
   
   public
    hFileMapObj:THandle;// FaleMapping
    lpBaseAddress: PData;//""       
    fdata: TData; //          
   
    ffilename: string;
    _prop_FileName:string;
    
    _data_FileName:THI_Event;
    _data_Data:THI_Event;
    _event_onError:THI_Event;
    _event_onRead:THI_Event;
    
    constructor Create;
    destructor Destroy; override;
    procedure Init;
    procedure _work_doWrite(var _Data:TData; Index:word);
    procedure _work_doRead(var _Data:TData; Index:word);

  end;

implementation

constructor THIFileMapping.Create;
begin
  inherited;
  InitAdd(Init);
end;

destructor THIFileMapping.Destroy;
begin
  UnMapViewOfFile(lpBaseAddress);
  CloseHandle(hFileMapObj);
  inherited;
end;

procedure THIFileMapping.Init;
var dt: TData;
begin
  ffilename := ReadString(dt,_data_FileName,_prop_FileName);
  _hi_OnEvent(_event_onError, ffilename);
  If (hFileMapObj = 0) then
    hFileMapObj:=CreateFileMapping(MAXDWORD,Nil,PAGE_READWRITE,0,4,PChar(ffilename));
  If (hFileMapObj=0) Then
    _hi_OnEvent(_event_onError, 'Error: create FileMapping!')  
  Else
    lpBaseAddress:=MapViewOfFile(hFileMapObj,FILE_MAP_WRITE,0,0,0);
  If lpBaseAddress=Nil Then
    _hi_OnEvent(_event_onError, 'Error: open FileMapping!'); 
end;

procedure THIFileMapping._work_doWrite;
begin
  fdata := ReadData(_Data,_data_Data);
  lpBaseAddress^ := fdata;
end;

procedure THIFileMapping._work_doRead;
begin
  If (hFileMapObj<>0) Then
    _hi_OnEvent_(_event_onRead, lpBaseAddress^);
end;

end.
